/*

by Luigi Auriemma

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>



#define VER     "0.1"
#define BUFFSZ  8192

#define WAIT    printf("\n  Press RETURN to exit\n"); \
                fgetc(stdin);



char *catch_it(char *data);
void empire_earth_2_gamespypwd(unsigned char *pwd);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    int     found = 0;
    char    buff[BUFFSZ],
            *p;


    setbuf(stdout, NULL);

    fputs("\n"
        "Empire Earth 2 online account password decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <settings.cfg>\n"
            "\n"
            " The file is located in the Application Data folder of the user, like:\n"
            "   c:\\windows\\Application Data\\Sierra\\Empire Earth II\\settings\\settings.cfg\n"
            "\n", argv[0]);
        WAIT;
        exit(1);
    }

    printf("- open file:  %s\n\n", argv[1]);
    fd = fopen(argv[1], "rb");
    if(!fd) std_err();

    while(fgets(buff, BUFFSZ, fd)) {
        if(strstr(buff, "GameSpyLogin")) found = 1;

        if(!found) continue;

        if(strstr(buff, "email")) {
            printf("  E-mail:    %s\n", catch_it(buff));

        } else if(strstr(buff, "nickname")) {
            printf("  Nickname:  %s\n", catch_it(buff));

        } else if(strstr(buff, "password")) {
            p = catch_it(buff);
            empire_earth_2_gamespypwd(p);
            printf("  Password:  %s\n", p);

        } else if(strchr(buff, '}')) {
            found = 0;
        }
    }

    fclose(fd);
    WAIT;
    return(0);
}



char *catch_it(char *data) {
    char    *ret = NULL,
            *p;

    for(p = data; *p; p++) {
        if(*p == '"') {
            if(ret) {
                if(*(p + 1) <= '\r') {
                    *p = 0;
                    break;
                }
            } else {
                ret = p + 1;
            }
        }
    }
    if(!ret) ret = data;
    return(ret);
}



void empire_earth_2_gamespypwd(unsigned char *pwd) {
    while(*pwd) {
        if((*pwd >= 'a') && (*pwd <= 'z')) {
            *pwd += 9;
            if(*pwd > 'z') *pwd -= 26;

        } else if((*pwd >= 'A') && (*pwd <= 'Z')) {
            *pwd -= 7;
            if(*pwd < 'A') *pwd += 26;

        } else if((*pwd >= '0') && (*pwd <= '9')) {
            *pwd += 7;
            if(*pwd > '9') *pwd -= 10;
        }

        pwd++;
    }
}



void std_err(void) {
    perror("\nError");
    WAIT;
    exit(1);
}

